Index: /extensions/UserAdvManager/trunk/include/functions.inc.php
===================================================================
--- /extensions/UserAdvManager/trunk/include/functions.inc.php	(revision 21074)
+++ /extensions/UserAdvManager/trunk/include/functions.inc.php	(revision 21075)
@@ -40,5 +40,5 @@
  
   // Check mandatory email address for email exclusion
-  if (!$conf['obligatory_user_mail_address'] and $conf_UAM[10] == 'true')
+  if (!$conf['obligatory_user_mail_address'] and $conf_UAM['MAILEXCLUSION'] == 'true')
   {
     array_push($page['warnings'], l10n('UAM_mail_exclusion_error'));
@@ -64,5 +64,5 @@
   if (!is_admin() and !is_a_guest() and $user['username'] != "16" and $user['username'] != "18")
   {
-    if ((isset($conf_UAM[15]) and $conf_UAM[15] == 'true') or (isset($conf_UAM[18]) and $conf_UAM[18] == 'true'))
+    if ((isset($conf_UAM['GHOSTRACKER']) and $conf_UAM['GHOSTRACKER'] == 'true') or (isset($conf_UAM['ADDLASTVISIT']) and $conf_UAM['ADDLASTVISIT'] == 'true'))
     {
       $userid = get_userid($user['username']);
@@ -103,5 +103,5 @@
 
     // Perform user logout after registration if not validated
-    if ((isset($conf_UAM[39]) and $conf_UAM[39] == 'true') and !UAM_UsrReg_Verif($user['id']) and !is_admin() and !is_webmaster() )
+    if ((isset($conf_UAM['REJECTCONNECT']) and $conf_UAM['REJECTCONNECT'] == 'true') and !UAM_UsrReg_Verif($user['id']) and !is_admin() and !is_webmaster() )
     {
       invalidate_user_cache();
@@ -141,5 +141,5 @@
     //Bug 2829 fix not working - if (isset($page['page']) and ($page['page'] != 'user_list'))
     //{
-      if (isset($conf_UAM[1]) and $conf_UAM[1] == 'local')
+      if (isset($conf_UAM['CONFIRM_MAIL']) and $conf_UAM['CONFIRM_MAIL'] == 'local')
       {
         // This is to set user to "waiting" group or status and without ConfirMail until admin validation
@@ -157,11 +157,11 @@
       // Sending registration confirmation by email
       // ------------------------------------------
-      elseif (isset($conf_UAM[1]) and $conf_UAM[1] == 'true')
-      {
-        if (is_admin() and isset($conf_UAM[19]) and $conf_UAM[19] == 'true')
+      elseif (isset($conf_UAM['CONFIRM_MAIL']) and $conf_UAM['CONFIRM_MAIL'] == 'true')
+      {
+        if (is_admin() and isset($conf_UAM['ADMINCONFMAIL']) and $conf_UAM['ADMINCONFMAIL'] == 'true')
         {
           SendMail2User(1, $register_user['id'], $register_user['username'], $passwd, $register_user['email'], true); 
         }
-        elseif (is_admin() and isset($conf_UAM[19]) and $conf_UAM[19] == 'false')
+        elseif (is_admin() and isset($conf_UAM['ADMINCONFMAIL']) and $conf_UAM['ADMINCONFMAIL'] == 'false')
         {
           SendMail2User(1, $register_user['id'], $register_user['username'], $passwd, $register_user['email'], false);
@@ -217,5 +217,5 @@
     // Password enforcement control
     // ----------------------------
-    if (isset($conf_UAM[12]) and $conf_UAM[12] == 'true' and !empty($conf_UAM[13]))
+    if (isset($conf_UAM['PASSWORDENF']) and $conf_UAM['PASSWORDENF'] == 'true' and !empty($conf_UAM['PASSWORD_SCORE']))
     {
       if (!empty($user['password']) and !is_admin())
@@ -223,19 +223,19 @@
         $PasswordCheck = testpassword($user['password']);
   
-        if ($PasswordCheck < $conf_UAM[13])
+        if ($PasswordCheck < $conf_UAM['PASSWORD_SCORE'])
         {
           $message = get_l10n_args('UAM_reg_err_login4_%s', $PasswordCheck);
-          $lang['reg_err_pass'] = l10n_args($message).$conf_UAM[13];
+          $lang['reg_err_pass'] = l10n_args($message).$conf_UAM['PASSWORD_SCORE'];
           array_push($errors, $lang['reg_err_pass']);
         }
       }
-      else if (!empty($user['password']) and is_admin() and isset($conf_UAM[14]) and $conf_UAM[14] == 'true')
+      else if (!empty($user['password']) and is_admin() and isset($conf_UAM['ADMINPASSWENF']) and $conf_UAM['ADMINPASSWENF'] == 'true')
       {
         $PasswordCheck = testpassword($user['password']);
   
-        if ($PasswordCheck < $conf_UAM[13])
+        if ($PasswordCheck < $conf_UAM['PASSWORD_SCORE'])
         {
           $message = get_l10n_args('UAM_reg_err_login4_%s', $PasswordCheck);
-          $lang['reg_err_pass'] = l10n_args($message).$conf_UAM[13];
+          $lang['reg_err_pass'] = l10n_args($message).$conf_UAM['PASSWORD_SCORE'];
           array_push($errors, $lang['reg_err_pass']);
         }
@@ -245,7 +245,7 @@
     // Username without forbidden keys
     // -------------------------------
-    if (isset($conf_UAM[5]) and $conf_UAM[5] == 'true' and !empty($user['username']) and ValidateUsername($user['username']) and !is_admin())
-    {
-      $lang['reg_err_login1'] = l10n('UAM_reg_err_login2')."'".$conf_UAM[6]."'";
+    if (isset($conf_UAM['USERNAME_CHAR']) and $conf_UAM['USERNAME_CHAR'] == 'true' and !empty($user['username']) and ValidateUsername($user['username']) and !is_admin())
+    {
+      $lang['reg_err_login1'] = l10n('UAM_reg_err_login2')."'".$conf_UAM['USERNAME_CHAR_LIST']."'";
       array_push($errors, $lang['reg_err_login1']);
     }
@@ -253,7 +253,7 @@
     // Email without forbidden domains
     // -------------------------------
-    if (isset($conf_UAM[10]) and $conf_UAM[10] == 'true' and !empty($user['email']) and ValidateEmailProvider($user['email']) and !is_admin())
-    {
-      $lang['reg_err_login1'] = l10n('UAM_reg_err_login5')."'".$conf_UAM[11]."'";
+    if (isset($conf_UAM['MAILEXCLUSION']) and $conf_UAM['MAILEXCLUSION'] == 'true' and !empty($user['email']) and ValidateEmailProvider($user['email']) and !is_admin())
+    {
+      $lang['reg_err_login1'] = l10n('UAM_reg_err_login5')."'".$conf_UAM['MAILEXCLUSION_LIST']."'";
       array_push($errors, $lang['reg_err_login1']);
     }
@@ -274,5 +274,5 @@
   // Update first redirection parameter
   // ----------------------------------
-  if ((isset($conf_UAM[20]) and $conf_UAM[20] == 'true'))
+  if ((isset($conf_UAM['REDIRTOPROFILE']) and $conf_UAM['REDIRTOPROFILE'] == 'true'))
   {
     $user_idsOK = array();
@@ -292,5 +292,5 @@
   // Special message display for password reset
   // ------------------------------------------
-  if ((isset($conf_UAM[38]) and $conf_UAM[38] == 'true'))
+  if ((isset($conf_UAM['PWDRESET']) and $conf_UAM['PWDRESET'] == 'true'))
   {
     if (UAM_check_pwgreset($user['id']))
@@ -306,9 +306,9 @@
     // Email without forbidden domains
     // -------------------------------
-    if (isset($conf_UAM[10]) and $conf_UAM[10] == 'true' and !empty($_POST['mail_address']))
+    if (isset($conf_UAM['MAILEXCLUSION']) and $conf_UAM['MAILEXCLUSION'] == 'true' and !empty($_POST['mail_address']))
     {
       if (ValidateEmailProvider($_POST['mail_address']))
       {
-        $template->append('errors', l10n('UAM_reg_err_login5')."'".$conf_UAM[11]."'");
+        $template->append('errors', l10n('UAM_reg_err_login5')."'".$conf_UAM['MAILEXCLUSION_LIST']."'");
         unset($_POST['validate']);
       }
@@ -317,5 +317,5 @@
     // Password reset control
     // ----------------------
-    if (isset($conf_UAM[38]) and $conf_UAM[38] == 'true' and UAM_check_pwgreset($user['id']))
+    if (isset($conf_UAM['PWDRESET']) and $conf_UAM['PWDRESET'] == 'true' and UAM_check_pwgreset($user['id']))
     {
       // if password not changed then pwdreset field = true else pwdreset field = false
@@ -341,12 +341,12 @@
       // Password enforcement control
       // ----------------------------
-      if (isset($conf_UAM[12]) and $conf_UAM[12] == 'true' and !empty($conf_UAM[13]))
+      if (isset($conf_UAM['PASSWORDENF']) and $conf_UAM['PASSWORDENF'] == 'true' and !empty($conf_UAM['PASSWORD_SCORE']))
       {
         $PasswordCheck = testpassword($_POST['use_new_pwd']);
 
-        if ($PasswordCheck < $conf_UAM[13])
+        if ($PasswordCheck < $conf_UAM['PASSWORD_SCORE'])
         {
           $message = get_l10n_args('UAM_reg_err_login4_%s', $PasswordCheck);
-          $template->append('errors', l10n_args($message).$conf_UAM[13]);
+          $template->append('errors', l10n_args($message).$conf_UAM['PASSWORD_SCORE']);
           unset($_POST['use_new_pwd']);
           unset($_POST['validate']);
@@ -357,5 +357,5 @@
     // Sending registration confirmation by email
     // ------------------------------------------
-    if ((isset($conf_UAM[1]) and $conf_UAM[1] == 'true') or (isset($conf_UAM[1]) and $conf_UAM[1] == 'local'))
+    if ((isset($conf_UAM['CONFIRM_MAIL']) and $conf_UAM['CONFIRM_MAIL'] == 'true') or (isset($conf_UAM['CONFIRM_MAIL']) and $conf_UAM['CONFIRM_MAIL'] == 'local'))
     {
       $confirm_mail_need = false;
@@ -373,5 +373,5 @@
         // This is to send a new validation key
         // ------------------------------------
-        if ($_POST['mail_address'] != $current_email and (isset($conf_UAM[1]) and $conf_UAM[1] == 'true'))
+        if ($_POST['mail_address'] != $current_email and (isset($conf_UAM['CONFIRM_MAIL']) and $conf_UAM['CONFIRM_MAIL'] == 'true'))
         {
           SetPermission($user['id']);// Set to "waiting" group or status until user validation
@@ -382,5 +382,5 @@
         // This is to set the user to "waiting" group or status until admin validation
         // ---------------------------------------------------------------------------
-        elseif ($_POST['mail_address'] != $current_email and (isset($conf_UAM[1]) and $conf_UAM[1] == 'local'))
+        elseif ($_POST['mail_address'] != $current_email and (isset($conf_UAM['CONFIRM_MAIL']) and $conf_UAM['CONFIRM_MAIL'] == 'local'))
         {
           SetPermission($user['id']);// Set to "waiting" group or status until admin validation
@@ -390,5 +390,5 @@
       }
 
-      if (((!empty($_POST['use_new_pwd']) and (isset($conf_UAM[0]) and $conf_UAM[0] == 'true')) or $confirm_mail_need))
+      if (((!empty($_POST['use_new_pwd']) and (isset($conf_UAM['MAIL_INFO']) and $conf_UAM['MAIL_INFO'] == 'true')) or $confirm_mail_need))
       {
         $query = '
@@ -423,5 +423,5 @@
   // Performing GhostTracker scheduled tasks
   // ---------------------------------------
-  if ((isset($conf_UAM[21]) and $conf_UAM[21] == 'true'))
+  if ((isset($conf_UAM['GTAUTO']) and $conf_UAM['GTAUTO'] == 'true'))
   {
     UAM_GT_ScheduledTasks();
@@ -430,5 +430,5 @@
   // Performing User validation scheduled tasks
   // ------------------------------------------
-  if ((isset($conf_UAM[30]) and $conf_UAM[30] == 'true'))
+  if ((isset($conf_UAM['USRAUTO']) and $conf_UAM['USRAUTO'] == 'true'))
   {
     UAM_USR_ScheduledTasks();
@@ -436,9 +436,9 @@
 
   // Avoid login into public galleries until registration confirmation is done
-  if ((isset($conf_UAM[39]) and $conf_UAM[39] == 'false') or ((isset($conf_UAM[39]) and $conf_UAM[39] == 'true') and UAM_UsrReg_Verif($user['id'])) or  (!is_admin() and !is_webmaster()))
+  if ((isset($conf_UAM['REJECTCONNECT']) and $conf_UAM['REJECTCONNECT'] == 'false') or ((isset($conf_UAM['REJECTCONNECT']) and $conf_UAM['REJECTCONNECT'] == 'true') and UAM_UsrReg_Verif($user['id'])) or  (!is_admin() and !is_webmaster()))
   {
     // Performing redirection to profile page on first login
     // -----------------------------------------------------
-    if ((isset($conf_UAM[20]) and $conf_UAM[20] == 'true'))
+    if ((isset($conf_UAM['REDIRTOPROFILE']) and $conf_UAM['REDIRTOPROFILE'] == 'true'))
     {
       $query ='
@@ -459,5 +459,5 @@
     // Performing redirection to profile page for password reset
     // ---------------------------------------------------------
-    if ((isset($conf_UAM[38]) and $conf_UAM[38] == 'true'))
+    if ((isset($conf_UAM['PWDRESET']) and $conf_UAM['PWDRESET'] == 'true'))
     {
       $query ='
@@ -477,5 +477,5 @@
     }
   }
-  elseif ((isset($conf_UAM[39]) and $conf_UAM[39] == 'true') and !UAM_UsrReg_Verif($user['id']) and !is_admin() and !is_webmaster())
+  elseif ((isset($conf_UAM['REJECTCONNECT']) and $conf_UAM['REJECTCONNECT'] == 'true') and !UAM_UsrReg_Verif($user['id']) and !is_admin() and !is_webmaster())
   {
     // Logged-in user cleanup, session destruction and redirected to custom page
@@ -543,5 +543,5 @@
   // Auto group, status or privacy level downgrade and autodeletion if user already reminded
   // ---------------------------------------------------------------------------------------
-  if ((isset($conf_UAM[21]) and $conf_UAM[21] == 'true') and ((isset($conf_UAM[25]) and $conf_UAM[25] <> -1) or (isset($conf_UAM[26]) and $conf_UAM[26] <> -1) or (isset($conf_UAM[37]) and $conf_UAM[37] <> -1)))
+  if ((isset($conf_UAM['GTAUTO']) and $conf_UAM['GTAUTO'] == 'true') and ((isset($conf_UAM['DOWNGRADE_GROUP']) and $conf_UAM['DOWNGRADE_GROUP'] <> -1) or (isset($conf_UAM['DOWNGRADE_STATUS']) and $conf_UAM['DOWNGRADE_STATUS'] <> -1) or (isset($conf_UAM['DOWNGRADE_LEVEL']) and $conf_UAM['DOWNGRADE_LEVEL'] <> -1)))
   {
     if (count($collection) > 0)
@@ -625,5 +625,5 @@
             // Delete user from all groups
             // ---------------------------
-            if ($conf_UAM[2] <> -1 and $conf_UAM[3] <> -1)
+            if ($conf_UAM['NO_CONFIRM_GROUP'] <> -1 and $conf_UAM['VALIDATED_GROUP'] <> -1)
             {
             		$query = '
@@ -631,7 +631,7 @@
 WHERE user_id = '.$user_id.'
   AND (
-    group_id = '.$conf_UAM[2].'
+    group_id = '.$conf_UAM['NO_CONFIRM_GROUP'].'
   OR 
-    group_id = '.$conf_UAM[3].'
+    group_id = '.$conf_UAM['VALIDATED_GROUP'].'
   )
 ;';
@@ -641,9 +641,9 @@
             // Change user status
             // ------------------
-            if ($conf_UAM[26] <> -1)
+            if ($conf_UAM['DOWNGRADE_STATUS'] <> -1)
             {
               $query = '
 UPDATE '.USER_INFOS_TABLE.'
-SET status = "'.$conf_UAM[26].'"
+SET status = "'.$conf_UAM['DOWNGRADE_STATUS'].'"
 WHERE user_id = '.$user_id.'
 ;';
@@ -653,5 +653,5 @@
             // Change user group
             // -----------------
-            if ($conf_UAM[25] <> -1)
+            if ($conf_UAM['DOWNGRADE_GROUP'] <> -1)
             {
               $query = '
@@ -659,5 +659,5 @@
   (user_id, group_id)
 VALUES
-  ('.$user_id.', "'.$conf_UAM[25].'")
+  ('.$user_id.', "'.$conf_UAM['DOWNGRADE_GROUP'].'")
 ;';
               pwg_query($query);
@@ -666,9 +666,9 @@
             // Change user privacy level
             // -------------------------
-            if ($conf_UAM[37] <> -1)
+            if ($conf_UAM['DOWNGRADE_LEVEL'] <> -1)
             {
               $query = '
 UPDATE '.USER_INFOS_TABLE.'
-SET level = "'.$conf_UAM[37].'"
+SET level = "'.$conf_UAM['DOWNGRADE_LEVEL'].'"
 WHERE user_id = '.$user_id.'
 ;';
@@ -678,5 +678,5 @@
             // Auto send email notification on group / status downgrade
             // --------------------------------------------------------
-            if (isset($conf_UAM[22]) and $conf_UAM[22] == 'true')
+            if (isset($conf_UAM['GTAUTOMAIL']) and $conf_UAM['GTAUTOMAIL'] == 'true')
             {
               // Set reminder true
@@ -754,5 +754,5 @@
   // Unvalidated accounts auto email sending and autodeletion if user already reminded
   // ---------------------------------------------------------------------------------
-  if ((isset($conf_UAM[30]) and $conf_UAM[30] == 'true'))
+  if ((isset($conf_UAM['USRAUTO']) and $conf_UAM['USRAUTO'] == 'true'))
   {
     if (count($collection) > 0)
@@ -782,5 +782,5 @@
         // If never reminded before, send reminder and set reminder True
         // -------------------------------------------------------------
-        if (!$reminder and isset($conf_UAM[32]) and $conf_UAM[32] == 'true')
+        if (!$reminder and isset($conf_UAM['USRAUTOMAIL']) and $conf_UAM['USRAUTOMAIL'] == 'true')
         {
           $typemail = 1;
@@ -836,5 +836,5 @@
           // If never reminded before, send reminder and set reminder True
           // -------------------------------------------------------------
-          if (!$reminder and isset($conf_UAM[32]) and $conf_UAM[32] == 'true')
+          if (!$reminder and isset($conf_UAM['USRAUTOMAIL']) and $conf_UAM['USRAUTOMAIL'] == 'true')
           {
             $typemail = 1;
@@ -884,7 +884,7 @@
       // Email without forbidden domains
       // -------------------------------
-      if (isset($conf_UAM[10]) and $conf_UAM[10] == 'true' and !empty($_POST['email']) and ValidateEmailProvider($_POST['email']))
-      {
-        $template->append('errors', l10n('UAM_reg_err_login5')."'".$conf_UAM[11]."'");
+      if (isset($conf_UAM['MAILEXCLUSION']) and $conf_UAM['MAILEXCLUSION'] == 'true' and !empty($_POST['email']) and ValidateEmailProvider($_POST['email']))
+      {
+        $template->append('errors', l10n('UAM_reg_err_login5')."'".$conf_UAM['MAILEXCLUSION_LIST']."'");
         unset($_POST['submit_add']);
       }
@@ -915,5 +915,5 @@
 
     // Connexion rejected until validation
-    if (isset($conf_UAM[40]) and !empty($conf_UAM[40]) and $_GET['UAM_msg']=="rejected")
+    if (isset($conf_UAM['REJECTCONNECT_TEXT']) and !empty($conf_UAM['REJECTCONNECT_TEXT']) and $_GET['UAM_msg']=="rejected")
     {
       // Management of Extension flags ([mygallery], [myurl])
@@ -926,7 +926,7 @@
       if (function_exists('get_user_language_desc'))
       {
-        $custom_text = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[40]));
-      }
-      else $custom_text = l10n(preg_replace($patterns, $replacements, $conf_UAM[40]));
+        $custom_text = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['REJECTCONNECT_TEXT']));
+      }
+      else $custom_text = l10n(preg_replace($patterns, $replacements, $conf_UAM['REJECTCONNECT_TEXT']));
 
       $page["errors"][]=$custom_text;
@@ -934,5 +934,5 @@
 
     // User account deleted after validation deadline - Triggered by any other user
-    elseif (isset($conf_UAM[23]) and !empty($conf_UAM[23]) and $_GET['UAM_msg']=="deleted")
+    elseif (isset($conf_UAM['GTAUTODEL']) and !empty($conf_UAM['GTAUTODEL']) and $_GET['UAM_msg']=="deleted")
     {
       // Management of Extension flags ([mygallery], [myurl]) - [username] flag can't be used here
@@ -945,7 +945,7 @@
       if (function_exists('get_user_language_desc'))
       {
-        $custom_text = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[23]));
-      }
-      else $custom_text = l10n(preg_replace($patterns, $replacements, $conf_UAM[23]));
+        $custom_text = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['GTAUTODEL']));
+      }
+      else $custom_text = l10n(preg_replace($patterns, $replacements, $conf_UAM['GTAUTODEL']));
 
       $page["errors"][]=$custom_text;
@@ -953,5 +953,5 @@
 
     // User account deleted after validation deadline - Triggered by user himself
-    elseif (isset($conf_UAM[31]) and !empty($conf_UAM[31]) and $_GET['UAM_msg']=="deleted")
+    elseif (isset($conf_UAM['USRAUTODEL']) and !empty($conf_UAM['USRAUTODEL']) and $_GET['UAM_msg']=="deleted")
     {
       // Management of Extension flags ([mygallery], [myurl]) - [username] flag can't be used here
@@ -964,7 +964,7 @@
       if (function_exists('get_user_language_desc'))
       {
-        $custom_text = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[31]));
-      }
-      else $custom_text = l10n(preg_replace($patterns, $replacements, $conf_UAM[31]));
+        $custom_text = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['USRAUTODEL']));
+      }
+      else $custom_text = l10n(preg_replace($patterns, $replacements, $conf_UAM['USRAUTODEL']));
 
       $page["errors"][]=$custom_text;
@@ -1000,5 +1000,5 @@
     if (VerifyConfirmMail($key))
     {
-      if (isset($conf_UAM[1]) and $conf_UAM[1] == 'local')
+      if (isset($conf_UAM['CONFIRM_MAIL']) and $conf_UAM['CONFIRM_MAIL'] == 'local')
       {
         validation_mail($userid);
@@ -1030,5 +1030,5 @@
       }
 
-      if (isset($conf_UAM_ConfirmMail[5]) and !empty($conf_UAM_ConfirmMail[5]))
+      if (isset($conf_UAM_ConfirmMail['CONFIRMMAIL_CUSTOM_TXT1']) and !empty($conf_UAM_ConfirmMail['CONFIRMMAIL_CUSTOM_TXT1']))
       {
         // Management of Extension flags ([username], [mygallery], [myurl])
@@ -1043,9 +1043,9 @@
         if (function_exists('get_user_language_desc'))
         {
-          $custom_text = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM_ConfirmMail[5]));
+          $custom_text = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM_ConfirmMail['CONFIRMMAIL_CUSTOM_TXT1']));
         }
         else
         {
-          $custom_text = l10n(preg_replace($patterns, $replacements, $conf_UAM_ConfirmMail[5]));
+          $custom_text = l10n(preg_replace($patterns, $replacements, $conf_UAM_ConfirmMail['CONFIRMMAIL_CUSTOM_TXT1']));
         }
         $page['infos'][]=$custom_text;
@@ -1054,5 +1054,5 @@
     else
     {
-      if (isset($conf_UAM_ConfirmMail[6]) and !empty($conf_UAM_ConfirmMail[6]))
+      if (isset($conf_UAM_ConfirmMail['CONFIRMMAIL_CUSTOM_TXT2']) and !empty($conf_UAM_ConfirmMail['CONFIRMMAIL_CUSTOM_TXT2']))
       {
         // Management of Extension flags ([username], [mygallery], [myurl])
@@ -1067,9 +1067,9 @@
         if (function_exists('get_user_language_desc'))
         {
-          $custom_text = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM_ConfirmMail[6]));
+          $custom_text = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM_ConfirmMail['CONFIRMMAIL_CUSTOM_TXT2']));
         }
         else
         {
-          $custom_text = l10n(preg_replace($patterns, $replacements, $conf_UAM_ConfirmMail[6]));
+          $custom_text = l10n(preg_replace($patterns, $replacements, $conf_UAM_ConfirmMail['CONFIRMMAIL_CUSTOM_TXT2']));
         }
 
@@ -1100,5 +1100,5 @@
   $conf_UAM = unserialize($conf['UserAdvManager']);
 
-  if (isset($conf_UAM[28]) and $conf_UAM[28] == 'true')
+  if (isset($conf_UAM['CUSTOMPASSWRETR']) and $conf_UAM['CUSTOMPASSWRETR'] == 'true')
   {
     // Management of Extension flags ([mygallery], [myurl])
@@ -1108,5 +1108,5 @@
     $replacements[] = get_gallery_home_url();
 
-    $infos = preg_replace($patterns, $replacements, $conf_UAM[29])."\n"."\n".$infos;
+    $infos = preg_replace($patterns, $replacements, $conf_UAM['CUSTOMPASSWRETR_TEXT'])."\n"."\n".$infos;
   }
   return $infos;
@@ -1162,5 +1162,5 @@
   {
     case 1: // Confirmation email on user registration - Without information email (already managed by Piwigo)
-      if (isset($conf_UAM[41]) and !empty($conf_UAM[41]))
+      if (isset($conf_UAM['CONFIRMMAIL_SUBJECT']) and !empty($conf_UAM['CONFIRMMAIL_SUBJECT']))
       {
         // Management of Extension flags ([username], [mygallery])
@@ -1173,7 +1173,7 @@
         if (function_exists('get_user_language_desc'))
         {
-          $subject = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[41]))."\n\n";
-        }
-        else $subject = l10n(preg_replace($patterns, $replacements, $conf_UAM[41]))."\n\n"; 
+          $subject = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['CONFIRMMAIL_SUBJECT']))."\n\n";
+        }
+        else $subject = l10n(preg_replace($patterns, $replacements, $conf_UAM['CONFIRMMAIL_SUBJECT']))."\n\n"; 
       }
 
@@ -1181,5 +1181,5 @@
 
     case 2: // Confirmation email on user profile update - With information email if modification done in user profile
-      if (isset($conf_UAM[41]) and !empty($conf_UAM[41]))
+      if (isset($conf_UAM['CONFIRMMAIL_SUBJECT']) and !empty($conf_UAM['CONFIRMMAIL_SUBJECT']))
       {
         // Management of Extension flags ([username], [mygallery])
@@ -1192,12 +1192,12 @@
         if (function_exists('get_user_language_desc'))
         {
-          $subject = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[41]))."\n\n";
-        }
-        else $subject = l10n(preg_replace($patterns, $replacements, $conf_UAM[41]))."\n\n"; 
+          $subject = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['CONFIRMMAIL_SUBJECT']))."\n\n";
+        }
+        else $subject = l10n(preg_replace($patterns, $replacements, $conf_UAM['CONFIRMMAIL_SUBJECT']))."\n\n"; 
       }
 
       $password = !empty($password) ? $password : l10n('UAM_empty_pwd');
 
-      if (isset($conf_UAM[8]) and !empty($conf_UAM[8]))
+      if (isset($conf_UAM['MAILINFO_TEXT']) and !empty($conf_UAM['MAILINFO_TEXT']))
       {
         // Management of Extension flags ([username], [mygallery], [myurl])
@@ -1212,12 +1212,12 @@
         if (function_exists('get_user_language_desc'))
         {
-          $infos1_perso = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[8]))."\n\n";
-        }
-        else $infos1_perso = l10n(preg_replace($patterns, $replacements, $conf_UAM[8]))."\n\n"; 
-      }
-
-      if (isset($conf_UAM[0]) and $conf_UAM[0] == 'true')
-      {
-        if (isset($conf_UAM[34]) and $conf_UAM[34] == 'true') // Allow display of clear password in email
+          $infos1_perso = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['MAILINFO_TEXT']))."\n\n";
+        }
+        else $infos1_perso = l10n(preg_replace($patterns, $replacements, $conf_UAM['MAILINFO_TEXT']))."\n\n"; 
+      }
+
+      if (isset($conf_UAM['MAIL_INFO']) and $conf_UAM['MAIL_INFO'] == 'true')
+      {
+        if (isset($conf_UAM['HIDEPASSW']) and $conf_UAM['HIDEPASSW'] == 'true') // Allow display of clear password in email
         {
           $infos1 = array(
@@ -1243,5 +1243,5 @@
 
     case 3: // Only information email send to user if checked
-      if (isset($conf_UAM[43]) and !empty($conf_UAM[43]))
+      if (isset($conf_UAM['INFOMAIL_SUBJECT']) and !empty($conf_UAM['INFOMAIL_SUBJECT']))
       {
         // Management of Extension flags ([username], [mygallery])
@@ -1254,12 +1254,12 @@
         if (function_exists('get_user_language_desc'))
         {
-          $subject = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[43]))."\n\n";
-        }
-        else $subject = l10n(preg_replace($patterns, $replacements, $conf_UAM[43]))."\n\n"; 
+          $subject = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['INFOMAIL_SUBJECT']))."\n\n";
+        }
+        else $subject = l10n(preg_replace($patterns, $replacements, $conf_UAM['INFOMAIL_SUBJECT']))."\n\n"; 
       }
 
       $password = !empty($password) ? $password : l10n('UAM_no_update_pwd');
 
-      if (isset($conf_UAM[8]) and !empty($conf_UAM[8]))
+      if (isset($conf_UAM['MAILINFO_TEXT']) and !empty($conf_UAM['MAILINFO_TEXT']))
       {
         // Management of Extension flags ([username], [mygallery], [myurl])
@@ -1274,12 +1274,12 @@
         if (function_exists('get_user_language_desc'))
         {
-          $infos1_perso = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[8]))."\n\n";
-        }
-        else $infos1_perso = l10n(preg_replace($patterns, $replacements, $conf_UAM[8]))."\n\n"; 
-      }
-
-      if (isset($conf_UAM[0]) and $conf_UAM[0] == 'true')
-      {
-        if (isset($conf_UAM[34]) and $conf_UAM[34] == 'true') // Allow display of clear password in email
+          $infos1_perso = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['MAILINFO_TEXT']))."\n\n";
+        }
+        else $infos1_perso = l10n(preg_replace($patterns, $replacements, $conf_UAM['MAILINFO_TEXT']))."\n\n"; 
+      }
+
+      if (isset($conf_UAM['MAIL_INFO']) and $conf_UAM['MAIL_INFO'] == 'true')
+      {
+        if (isset($conf_UAM['HIDEPASSW']) and $conf_UAM['HIDEPASSW'] == 'true') // Allow display of clear password in email
         {
           $infos1 = array(
@@ -1305,5 +1305,5 @@
   }
 
-  if (isset($conf_UAM[1]) and ($conf_UAM[1] == 'true' or $conf_UAM[1] == 'local')  and $confirm) // Add confirmation link ?
+  if (isset($conf_UAM['CONFIRM_MAIL']) and ($conf_UAM['CONFIRM_MAIL'] == 'true' or $conf_UAM['CONFIRM_MAIL'] == 'local')  and $confirm) // Add confirmation link ?
   {
     $infos2 = array(
@@ -1312,5 +1312,5 @@
     );
 
-    if (isset($conf_UAM[9]) and !empty($conf_UAM[9])) // Add personal text in confirmation email ?
+    if (isset($conf_UAM['CONFIRMMAIL_TEXT']) and !empty($conf_UAM['CONFIRMMAIL_TEXT'])) // Add personal text in confirmation email ?
     {
       // Management of Extension flags ([username], [mygallery], [myurl], [Kdays])
@@ -1323,15 +1323,15 @@
       $replacements[] = get_gallery_home_url();
 
-      if (isset($conf_UAM_ConfirmMail[0]) and $conf_UAM_ConfirmMail[0] == 'true') // [Kdays] replacement only if related option is active
+      if (isset($conf_UAM_ConfirmMail['CONFIRMMAIL_TIMEOUT']) and $conf_UAM_ConfirmMail['CONFIRMMAIL_TIMEOUT'] == 'true') // [Kdays] replacement only if related option is active
       {
         $patterns[] = '#\[Kdays\]#i';
-        $replacements[] = $conf_UAM_ConfirmMail[1];
+        $replacements[] = $conf_UAM_ConfirmMail['CONFIRMMAIL_DELAY'];
       }
 
       if (function_exists('get_user_language_desc'))
       {
-        $infos2_perso = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[9]))."\n\n";
-      }
-      else $infos2_perso = l10n(preg_replace($patterns, $replacements, $conf_UAM[9]))."\n\n";
+        $infos2_perso = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['CONFIRMMAIL_TEXT']))."\n\n";
+      }
+      else $infos2_perso = l10n(preg_replace($patterns, $replacements, $conf_UAM['CONFIRMMAIL_TEXT']))."\n\n";
     }
   }
@@ -1339,5 +1339,5 @@
 // Sending the email with subject and contents
 // -------------------------------------------
-		if (isset($conf_UAM[1]) and $conf_UAM[1] == 'local')
+		if (isset($conf_UAM['CONFIRM_MAIL']) and $conf_UAM['CONFIRM_MAIL'] == 'local')
 		{
   		switch_lang_to(get_default_language());
@@ -1470,5 +1470,5 @@
   {
     case 1: //Generating email content for remind with a new key
-      if (isset($conf_UAM[42]) and !empty($conf_UAM[42]))
+      if (isset($conf_UAM['CONFIRMMAIL_REMAIL_SUBJECT']) and !empty($conf_UAM['CONFIRMMAIL_REMAIL_SUBJECT']))
       {
         // Management of Extension flags ([username], [mygallery])
@@ -1481,10 +1481,10 @@
         if (function_exists('get_user_language_desc'))
         {
-          $subject = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[42]))."\n\n";
-        }
-        else $subject = l10n(preg_replace($patterns, $replacements, $conf_UAM[42]))."\n\n"; 
-      }
-
-      if (isset($conf_UAM_ConfirmMail[2]) and !empty($conf_UAM_ConfirmMail[2]) and isset($conf_UAM_ConfirmMail[3]) and $conf_UAM_ConfirmMail[3] == 'true' and $confirm)
+          $subject = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['CONFIRMMAIL_REMAIL_SUBJECT']))."\n\n";
+        }
+        else $subject = l10n(preg_replace($patterns, $replacements, $conf_UAM['CONFIRMMAIL_REMAIL_SUBJECT']))."\n\n"; 
+      }
+
+      if (isset($conf_UAM_ConfirmMail['CONFIRMMAIL_REMAIL_TXT1']) and !empty($conf_UAM_ConfirmMail['CONFIRMMAIL_REMAIL_TXT1']) and isset($conf_UAM_ConfirmMail['CONFIRMMAIL_REMAIL']) and $conf_UAM_ConfirmMail['CONFIRMMAIL_REMAIL'] == 'true' and $confirm)
       {
     		// Management of Extension flags ([username], [mygallery], [myurl], [Kdays])
